diff -urN ../VisualBoyAdvance-1.7.2/src/win32/resource.h ./src/win32/resource.h
--- ../VisualBoyAdvance-1.7.2/src/win32/resource.h	2003-12-08 20:44:46 +0900
+++ ./src/win32/resource.h	2006-08-06 21:40:35 +0900
@@ -1,10 +1,11 @@
 //{{NO_DEPENDENCIES}}
-// Microsoft Developer Studio generated include file.
-// Used by VBA.rc
+// Microsoft Visual C++ generated include file.
+// Used by vba.rc
 //
 #define IDS_UNSUPPORTED_VBA_SGM         1
 #define IDS_CANNOT_LOAD_SGM             2
 #define IDS_SAVE_GAME_NOT_USING_BIOS    3
+#define IDC_DEFAULTS                    3
 #define IDS_SAVE_GAME_USING_BIOS        4
 #define IDS_UNSUPPORTED_SAVE_TYPE       5
 #define IDS_CANNOT_OPEN_FILE            6
@@ -43,7 +44,8 @@
 #define IDS_INVALID_CBA_CODE            39
 #define IDS_CBA_CODE_WARNING            40
 #define IDS_OUT_OF_MEMORY               41
-#define IDI_ICON                        101
+#define IDS_WRONG_GAMESHARK_CODE        42
+#define IDS_UNSUPPORTED_GAMESHARK_CODE  43
 #define IDD_REGISTERS                   102
 #define IDD_DEBUG                       103
 #define IDR_MENU                        104
@@ -93,6 +95,7 @@
 #define IDD_IO_VIEWER                   151
 #define IDD_MAX_SCALE                   154
 #define IDD_BUG_REPORT                  155
+#define IDD_GAME_OVERRIDES              156
 #define IDC_R0                          1000
 #define IDC_EDIT_UP                     1000
 #define IDC_R1                          1001
@@ -487,10 +490,15 @@
 #define IDC_BIT_3                       1253
 #define IDC_COPY                        1253
 #define IDC_BIT_4                       1254
+#define IDC_NAME                        1254
 #define IDC_BIT_5                       1255
+#define IDC_RTC                         1255
 #define IDC_BIT_6                       1256
+#define IDC_SAVE_TYPE                   1256
 #define IDC_BIT_7                       1257
+#define IDC_FLASH_SIZE                  1257
 #define IDC_BIT_8                       1258
+#define IDC_COMMENT                     1258
 #define IDC_BIT_9                       1259
 #define IDC_BIT_10                      1260
 #define IDC_BIT_11                      1261
@@ -498,6 +506,8 @@
 #define IDC_BIT_13                      1263
 #define IDC_BIT_14                      1264
 #define IDC_BIT_15                      1265
+#define IDC_MIRRORING                   1266
+#define IDC_LY                          1267
 #define ID_HELP_ABOUT                   40001
 #define ID_FILE_EXIT                    40002
 #define ID_OPTIONS_VIDEO_FRAMESKIP_0    40003
@@ -641,7 +651,6 @@
 #define ID_TOOLS_LOGGING                40156
 #define ID_OPTIONS_EMULATOR_SPEEDHACK   40157
 #define ID_OPTIONS_EMULATOR_SPEEDUPTOGGLE 40158
-#define ID_OPTIONS_EMULATOR_REMOVEINTROSGBA 40159
 #define ID_OPTIONS_FILTER16BIT_ADVANCEMAMESCALE2X 40160
 #define ID_OPTIONS_FILTER16BIT_SIMPLE2X 40161
 #define ID_FILE_RECENT_FREEZE           40162
@@ -727,7 +736,6 @@
 #define ID_OPTIONS_EMULATOR_REWINDINTERVAL 40262
 #define ID_FILE_TOGGLEMENU              40263
 #define ID_OPTIONS_EMULATOR_SAVETYPE_NONE 40264
-#define ID_OPTIONS_EMULATOR_SAVETYPE_ENHANCEDDETECTION 40265
 #define ID_TOOLS_IOVIEWER               40266
 #define ID_FILE_LOADGAME_MOSTRECENT     40267
 #define ID_FILE_SAVEGAME_OLDESTSLOT     40268
@@ -738,14 +746,18 @@
 #define ID_OPTIONS_VIDEO_FULLSCREENMAXSCALE 40273
 #define ID_OPTIONS_FILTER_HQ2X          40274
 #define ID_OPTIONS_FILTER_LQ2X          40275
+#define ID_OPTIONS_EMULATOR_GAMEOVERRIDES 40276
+#define ID_HELP_GNUPUBLICLICENSE        40277
+#define ID_OPTIONS_EMULATOR_GENERICFLASHCARD 40279
+#define ID_OPTIONS_SOUND_HARDWAREACCELERATION 40281
 
 // Next default values for new objects
 // 
 #ifdef APSTUDIO_INVOKED
 #ifndef APSTUDIO_READONLY_SYMBOLS
-#define _APS_NEXT_RESOURCE_VALUE        156
-#define _APS_NEXT_COMMAND_VALUE         40276
-#define _APS_NEXT_CONTROL_VALUE         1254
-#define _APS_NEXT_SYMED_VALUE           103
+#define _APS_NEXT_RESOURCE_VALUE        158
+#define _APS_NEXT_COMMAND_VALUE         40282
+#define _APS_NEXT_CONTROL_VALUE         1256
+#define _APS_NEXT_SYMED_VALUE           108
 #endif
 #endif
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/resource2.h ./src/win32/resource2.h
--- ../VisualBoyAdvance-1.7.2/src/win32/resource2.h	1970-01-01 09:00:00 +0900
+++ ./src/win32/resource2.h	2006-08-04 20:21:09 +0900
@@ -0,0 +1 @@
+#define IDI_ICON 101
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/skin.cpp ./src/win32/skin.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/skin.cpp	2004-02-29 22:04:54 +0900
+++ ./src/win32/skin.cpp	2006-06-07 06:04:21 +0900
@@ -147,10 +147,10 @@
   // --------------------------------------------------
   // change window style (get rid of the caption bar)
   // --------------------------------------------------
-  DWORD dwStyle = GetWindowLong(m_hWnd, GWL_STYLE);
+  LONG_PTR dwStyle = GetWindowLongPtr(m_hWnd, GWL_STYLE);
   m_dOldStyle = dwStyle;
   dwStyle &= ~(WS_CAPTION|WS_SIZEBOX);
-  SetWindowLong(m_hWnd, GWL_STYLE, dwStyle);
+  SetWindowLongPtr(m_hWnd, GWL_STYLE, dwStyle);
 
   RECT r;
   pWnd->GetWindowRect(&r);
@@ -168,7 +168,7 @@
     pWnd->SetWindowRgn(m_rgnSkin, true);    
 
   // subclass the window procedure
-  m_OldWndProc = (WNDPROC)SetWindowLong(m_hWnd, GWL_WNDPROC, (LONG)SkinWndProc);
+  m_OldWndProc = (WNDPROC)SetWindowLongPtr( m_hWnd, GWLP_WNDPROC, (LONG_PTR)SkinWndProc );
 
   // store a pointer to our class instance inside the window procedure.
   if (!SetProp(m_hWnd, "skin", (void*)this))
@@ -214,7 +214,7 @@
     SetWindowRgn(m_hWnd, NULL, true);
 
   // unsubclass the window procedure
-  OurWnd = (WNDPROC)SetWindowLong(m_hWnd, GWL_WNDPROC, (LONG)m_OldWndProc);
+  OurWnd = (WNDPROC)SetWindowLongPtr( m_hWnd, GWLP_WNDPROC, (LONG_PTR)m_OldWndProc );
 
   // remove the pointer to our class instance, but if we fail we don't care.
   RemoveProp(m_hWnd, "skin");
@@ -223,7 +223,7 @@
   // we failed to unhook the window.
   m_bHooked = ( OurWnd ? false : true );
 
-  SetWindowLong(m_hWnd, GWL_STYLE, m_dOldStyle);
+  SetWindowLongPtr(m_hWnd, GWL_STYLE, m_dOldStyle);
 
   RECT r;
 
@@ -533,7 +533,7 @@
 {
   // we will need a pointer to the associated class instance
   // (it was stored in the window before, remember?)
-  CSkin *pSkin = (CSkin*)GetProp(hWnd, "skin");
+  CSkin *pSkin = (CSkin*)GetProp(hWnd, _T("skin"));
 
   // to handle WM_PAINT
   PAINTSTRUCT ps;
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/skin.h ./src/win32/skin.h
--- ../VisualBoyAdvance-1.7.2/src/win32/skin.h	2004-05-13 22:31:53 +0900
+++ ./src/win32/skin.h	2006-05-27 23:47:33 +0900
@@ -67,7 +67,7 @@
 
   RECT      m_rect;
 
-  DWORD     m_dOldStyle;
+  LONG_PTR     m_dOldStyle;
   RECT      m_oldRect;
   int       m_nButtons;
   SkinButton *m_buttons;
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/skinButton.cpp ./src/win32/skinButton.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/skinButton.cpp	2004-05-13 23:14:10 +0900
+++ ./src/win32/skinButton.cpp	2006-08-26 00:27:16 +0900
@@ -97,7 +97,7 @@
   PAINTSTRUCT ps;
   HDC hDC = ::BeginPaint(m_hWnd, &ps);
   HDC memDC = ::CreateCompatibleDC(hDC);
-  UINT state = ::SendMessage(m_hWnd, BM_GETSTATE, 0, 0);
+  LRESULT state = ::SendMessage(m_hWnd, BM_GETSTATE, 0, 0);
   HBITMAP oldBitmap;
   if(state & BST_PUSHED)
     oldBitmap = (HBITMAP)SelectObject(memDC, downBmp);
@@ -126,6 +126,8 @@
   if(region != NULL)
     inside &= PtInRegion(region, pt.x, pt.y);
   if(inside) {
+    ReleaseCapture();
+    Invalidate();
     HWND hWnd = m_hWnd;
     if(idCommand != 0)
       GetParent()->SendMessage(WM_COMMAND, idCommand, 0);
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/stdafx.cpp ./src/win32/stdafx.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/stdafx.cpp	2004-05-13 23:13:56 +0900
+++ ./src/win32/stdafx.cpp	2006-05-27 23:47:33 +0900
@@ -16,11 +16,4 @@
 // along with this program; if not, write to the Free Software Foundation,
 // Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 
-// stdafx.cpp : source file that includes just the standard includes
-//      DialogSizer.pch will be the pre-compiled header
-//      stdafx.obj will contain the pre-compiled type information
-
-#include "stdafx.h"
-
-// TODO: reference any additional headers you need in STDAFX.H
-// and not in this file
+#include "stdafx.h"
\ No newline at end of file
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/stdafx.h ./src/win32/stdafx.h
--- ../VisualBoyAdvance-1.7.2/src/win32/stdafx.h	2004-05-13 22:28:48 +0900
+++ ./src/win32/stdafx.h	2006-05-27 23:47:33 +0900
@@ -33,6 +33,13 @@
 // Insert your headers here
 //#define WIN32_LEAN_AND_MEAN           // Exclude rarely-used stuff from Windows headers
 
+// Target for Windows 2000
+#define WINVER 0x0500
+#define _WIN32_WINNT 0x0500
+
+#define STRICT
+
+
 #include <afxwin.h>
 #include <afxcmn.h>
 #include <afxdlgs.h>
